Initial version of the ci-management repo
authorJan-Simon Möller <jsmoeller@linuxfoundation.org>
Tue, 16 Aug 2016 16:26:19 +0000 (18:26 +0200)
committerJan-Simon Möller <jsmoeller@linuxfoundation.org>
Wed, 17 Aug 2016 11:27:14 +0000 (13:27 +0200)
Based on the open-o template. Modified for AGL.

v2 fixed host key and only pushing ci-management jobs.
- fix macro vs. definition in file

Change-Id: I2de02a572a5d8ca1bf6b7a56bfd2e30bfe18fa9a
Signed-off-by: Jan-Simon Möller <jsmoeller@linuxfoundation.org>
26 files changed:
.gitignore [new file with mode: 0644]
.gitreview [new file with mode: 0644]
jenkins-scripts/README [new file with mode: 0644]
jenkins-scripts/basic_settings.sh [new file with mode: 0755]
jenkins-scripts/create_jenkins_user.sh [new file with mode: 0755]
jenkins-scripts/jenkins-init-script.sh [new file with mode: 0755]
jenkins-scripts/system_type.sh [new file with mode: 0755]
jenkins.ini.example [new file with mode: 0644]
jjb/ci-management/ci-management.yaml [new file with mode: 0644]
jjb/ci-management/include-raw-jjb-update.sh [new file with mode: 0644]
jjb/global-defaults.yaml [new file with mode: 0644]
jjb/global-macros.yaml [new file with mode: 0644]
packer/README.markdown [new file with mode: 0644]
packer/provision/basebuild.sh [new file with mode: 0644]
packer/provision/basebuild/.dummy [new file with mode: 0644]
packer/provision/baseline.sh [new file with mode: 0644]
packer/provision/null_data.sh [new file with mode: 0644]
packer/provision/rh-user_data.sh [new file with mode: 0644]
packer/provision/system_reseal.sh [new file with mode: 0644]
packer/templates/basebuild.json [new file with mode: 0644]
packer/vars/.gitignore [new file with mode: 0644]
packer/vars/cloud-env.json.example [new file with mode: 0644]
packer/vars/ubuntu-16.04.json [new file with mode: 0644]
scripts/.gitkeep [new file with mode: 0644]
scripts/check-unicode.sh [new file with mode: 0755]
test [new file with mode: 0644]

diff --git a/.gitignore b/.gitignore
new file mode 100644 (file)
index 0000000..51ff612
--- /dev/null
@@ -0,0 +1,18 @@
+# Ignore Vim temporary files
+.*.sw?
+
+# Ignore changes to the JJB Configuration File
+jenkins.ini
+
+# We don't want .netrc files since they're credential files
+.netrc
+
+# Maven
+target/
+
+# Vagrant
+.vagrant
+
+# IntelliJ
+.idea/
+*.iml
diff --git a/.gitreview b/.gitreview
new file mode 100644 (file)
index 0000000..0a87908
--- /dev/null
@@ -0,0 +1,4 @@
+[gerrit]
+host=gerrit-new.automotivelinux.org
+port=39418
+project=ci-management.git
diff --git a/jenkins-scripts/README b/jenkins-scripts/README
new file mode 100644 (file)
index 0000000..91485ef
--- /dev/null
@@ -0,0 +1,8 @@
+The scripts in this directory are used by the Jenkins spin-up component
+for dynamic minions.
+
+The spinup script will be as follows (${system_type} will be replaced
+with the appropriate system_type script)
+
+git clone https://gerrit.zephyrproject.org/r/p/ci-management.git /ci-management
+/ci-management/jenkins-scripts/jenkins-init-script.sh
diff --git a/jenkins-scripts/basic_settings.sh b/jenkins-scripts/basic_settings.sh
new file mode 100755 (executable)
index 0000000..0240ec2
--- /dev/null
@@ -0,0 +1,47 @@
+#!/bin/bash
+# @License EPL-1.0 <http://spdx.org/licenses/EPL-1.0>
+##############################################################################
+# Copyright (c) 2016 The Linux Foundation and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Eclipse Public License v1.0
+# which accompanies this distribution, and is available at
+# http://www.eclipse.org/legal/epl-v10.html
+##############################################################################
+
+case "$(facter operatingsystem)" in
+  Ubuntu)
+    apt-get update
+    ;;
+  *)
+    # Do nothing on other distros for now
+    ;;
+esac
+
+IPADDR=$(facter ipaddress)
+HOSTNAME=$(facter hostname)
+FQDN=$(facter fqdn)
+
+echo "${IPADDR} ${HOSTNAME} ${FQDN}" >> /etc/hosts
+
+#Increase limits
+cat <<EOF > /etc/security/limits.d/jenkins.conf
+jenkins         soft    nofile          16000
+jenkins         hard    nofile          16000
+EOF
+
+cat <<EOSSH >> /etc/ssh/ssh_config
+Host *
+  ServerAliveInterval 60
+
+# we don't want to do SSH host key checking on spin-up systems
+Host 10.30.96.* 10.30.97.*
+  StrictHostKeyChecking no
+  UserKnownHostsFile /dev/null
+EOSSH
+
+cat <<EOKNOWN >  /etc/ssh/ssh_known_hosts
+[gerrit-new.automotivelinux.org]:39418,[198.145.29.87]:39418 ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQDLlq8OD28YY+RRU2rcBxV0agWQsgD+ywpObFtjO0uxhxWWz0wtJdu0NDGpFH9AFE64AeBx7NFIYjuXWtWQIwSHgXyx0hejL9257YWsQ8dPsnEsUT6PehE68MA1eg4S5lT/9NjVeAhWgPBVNdtcP0oex2Pf/qr6aKZVUq9msemzZHAVmBKKHTFQTePW50JObQyXHQTSB572OV/haVob+3k6EQrtFdD3dg3/KDvgtuIjmW+Bp7amT7ZwtL0ekCWZqM6V8M1tqsy0WaJJhdjDf/Tc4d+wGNXFnU5niVDbBdlFVqQSVgGuSNIbu/y9ZRF14dOe97YMykxCJk7fDnsjdnmR
+EOKNOWN
+
+# vim: sw=2 ts=2 sts=2 et :
diff --git a/jenkins-scripts/create_jenkins_user.sh b/jenkins-scripts/create_jenkins_user.sh
new file mode 100755 (executable)
index 0000000..86a5c92
--- /dev/null
@@ -0,0 +1,41 @@
+#!/bin/bash
+# @License EPL-1.0 <http://spdx.org/licenses/EPL-1.0>
+##############################################################################
+# Copyright (c) 2016 The Linux Foundation and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Eclipse Public License v1.0
+# which accompanies this distribution, and is available at
+# http://www.eclipse.org/legal/epl-v10.html
+##############################################################################
+
+#######################
+# Create Jenkins User #
+#######################
+
+OS=$(facter operatingsystem | tr '[:upper:]' '[:lower:]')
+
+useradd -m -s /bin/bash jenkins
+
+# Check if docker group exists
+grep -q docker /etc/group
+if [ "$?" == '0' ]
+then
+  # Add jenkins user to docker group
+  usermod -a -G docker jenkins
+fi
+
+# Check if mock group exists
+grep -q mock /etc/group
+if [ "$?" == '0' ]
+then
+  # Add jenkins user to mock group so they can build Int/Pack's RPMs
+  usermod -a -G mock jenkins
+fi
+
+mkdir /home/jenkins/.ssh
+mkdir /w
+cp -r /home/${OS}/.ssh/authorized_keys /home/jenkins/.ssh/authorized_keys
+# Generate ssh key for use by Robot jobs
+echo -e 'y\n' | ssh-keygen -N "" -f /home/jenkins/.ssh/id_rsa -t rsa
+chown -R jenkins:jenkins /home/jenkins/.ssh /w
diff --git a/jenkins-scripts/jenkins-init-script.sh b/jenkins-scripts/jenkins-init-script.sh
new file mode 100755 (executable)
index 0000000..67987b5
--- /dev/null
@@ -0,0 +1,27 @@
+#!/bin/bash
+# @License EPL-1.0 <http://spdx.org/licenses/EPL-1.0>
+##############################################################################
+# Copyright (c) 2016 The Linux Foundation and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Eclipse Public License v1.0
+# which accompanies this distribution, and is available at
+# http://www.eclipse.org/legal/epl-v10.html
+##############################################################################
+
+# vim: ts=4 sw=4 sts=4 et :
+
+cd /ci-management/jenkins-scripts
+chmod +x ./*.sh
+./system_type.sh
+
+source /tmp/system_type.sh
+./basic_settings.sh
+if [ -f "${SYSTEM_TYPE}.sh" ]
+then
+    ./"${SYSTEM_TYPE}.sh"
+fi
+
+# Create the jenkins user last so that hopefully we don't have to deal with
+# guard files
+./create_jenkins_user.sh
diff --git a/jenkins-scripts/system_type.sh b/jenkins-scripts/system_type.sh
new file mode 100755 (executable)
index 0000000..9aeea20
--- /dev/null
@@ -0,0 +1,31 @@
+#!/bin/bash
+
+# @License EPL-1.0 <http://spdx.org/licenses/EPL-1.0>
+##############################################################################
+# Copyright (c) 2016 The Linux Foundation and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Eclipse Public License v1.0
+# which accompanies this distribution, and is available at
+# http://www.eclipse.org/legal/epl-v10.html
+##############################################################################
+
+HOST=$(/bin/hostname)
+SYSTEM_TYPE=''
+
+IFS=','
+for i in "basebuild,basebuild" \
+         "centos,centos" \
+         "trusty,trusty" \
+         "xenial,xenial"
+do set -- $i
+    if [[ $HOST == *"$1"* ]]; then
+        SYSTEM_TYPE="$2"
+        break
+    fi
+done
+
+# Write out the system type to an environment file to then be sourced
+echo "SYSTEM_TYPE=${SYSTEM_TYPE}" > /tmp/system_type.sh
+
+# vim: sw=4 ts=4 sts=4 et :
diff --git a/jenkins.ini.example b/jenkins.ini.example
new file mode 100644 (file)
index 0000000..c8486f8
--- /dev/null
@@ -0,0 +1,12 @@
+[job_builder]
+ignore_cache=True
+keep_descriptions=False
+include_path=.:scripts:~/git/
+recursive=True
+
+[jenkins]
+#user=jenkins
+#password=1234567890abcdef1234567890abcdef
+url=http://localhost:8080
+##### This is deprecated, use job_builder section instead
+#ignore_cache=True
diff --git a/jjb/ci-management/ci-management.yaml b/jjb/ci-management/ci-management.yaml
new file mode 100644 (file)
index 0000000..ceb8df8
--- /dev/null
@@ -0,0 +1,78 @@
+---
+- project:
+    name: ci-management-jobs
+    jobs:
+      - 'ci-management-verify-jjb'
+      - 'ci-management-merge'
+
+    project: 'ci-management'
+    branch: master
+
+- job-template:
+    name: ci-management-verify-jjb
+
+    project-type: freestyle
+    node: master
+    concurrent: true
+
+    parameters:
+      - agl-infra-parameters:
+          project: '{project}'
+          branch: 'master'
+          refspec: 'refs/heads/master'
+
+    scm:
+      - gerrit-trigger-scm:
+          refspec: '$GERRIT_REFSPEC'
+          choosing-strategy: 'gerrit'
+
+    wrappers:
+      - ssh-agent-credentials:
+          users:
+              - '{ssh-credentials}'
+
+    triggers:
+        - gerrit-trigger-patch-submitted:
+            name: '{project}'
+            branch: '{branch}'
+
+    builders:
+      - shell: |
+          ls -alh ; jenkins-jobs test --recursive jjb/
+      - ci-management-check-unicode
+
+- job-template:
+    name: 'ci-management-merge'
+
+    project-type: freestyle
+    node: master
+
+    build-discarder:
+      days-to-keep: 30
+      num-to-keep: 40
+      artifact-days-to-keep: -1
+      artifact-num-to-keep: 5
+
+    parameters:
+      - agl-infra-parameters:
+          project: '{project}'
+          branch: 'master'
+          refspec: 'refs/heads/master'
+
+    scm:
+      - gerrit-trigger-scm:
+          refspec: ''
+          choosing-strategy: 'default'
+
+    wrappers:
+      - agl-infra-wrappers:
+          build-timeout: '{build-timeout}'
+
+    triggers:
+      - gerrit-trigger-patch-merged:
+            name: '{project}'
+            branch: '{branch}'
+
+    builders:
+      - shell:
+          !include-raw-escape: include-raw-jjb-update.sh
diff --git a/jjb/ci-management/include-raw-jjb-update.sh b/jjb/ci-management/include-raw-jjb-update.sh
new file mode 100644 (file)
index 0000000..aca40dc
--- /dev/null
@@ -0,0 +1,10 @@
+jenkins-jobs update --delete-old --recursive jjb/
+
+# Submit patches for any jobs that can be auto updated
+function submitJJB {
+    git commit -asm "Update automated project templates"
+    git push origin HEAD:refs/for/master
+}
+
+gitdir=$(git rev-parse --git-dir); scp -p -P 39418 agl-jobbuilder@gerrit.automotievlinux.org.org:hooks/commit-msg ${gitdir}/hooks/
+git diff --exit-code || submitJJB
diff --git a/jjb/global-defaults.yaml b/jjb/global-defaults.yaml
new file mode 100644 (file)
index 0000000..155ae00
--- /dev/null
@@ -0,0 +1,14 @@
+---
+# GLOBAL jenkins defaults
+
+- defaults:
+    name: global
+
+    build-days-to-keep: 30
+    build-num-to-keep: 40
+    build-artifact-days-to-keep: -1
+    build-artifact-num-to-keep: 5
+    # Timeout in minutes
+    build-timeout: 360
+    build-node: ubuntu-16.04-basebuild-2c-1g
+    ssh-credentials: 'jenkins-gerrit-credentials'
diff --git a/jjb/global-macros.yaml b/jjb/global-macros.yaml
new file mode 100644 (file)
index 0000000..2222b66
--- /dev/null
@@ -0,0 +1,246 @@
+---
+# Global macros
+
+# PARAMETERS
+- parameter:
+    name: agl-infra-parameters
+    parameters:
+      - string:
+          name: PROJECT
+          default: '{project}'
+          # yamllint disable rule:line-length
+          description: "JJB configured PROJECT parameter to identify a Gerrit project"
+          # yamllint enable
+      - string:
+          name: GERRIT_BRANCH
+          default: '{branch}'
+          description: "JJB configured GERRIT_BRANCH parameter"
+      - string:
+          name: GERRIT_PROJECT
+          default: '{project}'
+          description: "GERRIT_PROJECT parameter if not given by trigger"
+      - string:
+          name: GERRIT_REFSPEC
+          default: '{refspec}'
+          description: "GERRIT_REFSPEC parameter if not given by trigger"
+
+# SCMS
+- scm:
+    name: git-scm
+    scm:
+      - git:
+          credentials-id: 'agl-jenkins-gerrit-user'
+          url: '$GIT_BASE'
+          refspec: ''
+          branches:
+            - 'origin/${branch}'
+          skip-tag: true
+          wipe-workspace: true
+
+- scm:
+    name: gerrit-trigger-scm
+    scm:
+      - git:
+          credentials-id: 'agl-jenkins-gerrit-user'
+          url: '$GIT_BASE'
+          refspec: '{refspec}'
+          branches:
+            - 'origin/$GERRIT_BRANCH'
+          skip-tag: true
+          choosing-strategy: '{choosing-strategy}'
+
+- scm:
+    name: gerrit-trigger-scm-basedir
+    scm:
+      - git:
+          credentials-id: 'agl-jenkins-gerrit-user'
+          url: '$GIT_BASE'
+          refspec: '{refspec}'
+          branches:
+            - 'origin/$GERRIT_BRANCH'
+          skip-tag: true
+          choosing-strategy: '{choosing-strategy}'
+          basedir: '{basedir}'
+
+- scm:
+    name: git-branch-scm
+    scm:
+      - git:
+          credentials-id: 'agl-jenkins-gerrit-user'
+          url: '$GIT_BASE'
+          refspec: ''
+          branches:
+            - 'origin/{branch}'
+          skip-tag: true
+          wipe-workspace: true
+
+# TRIGGERS
+- trigger:
+    name: gerrit-trigger-patch-submitted
+    triggers:
+      - gerrit:
+          server-name: 'gerrit-new.automotivelinux.org'
+          trigger-on:
+            - patchset-created-event:
+                exclude-drafts: 'false'
+                exclude-trivial-rebase: 'false'
+                exclude-no-code-change: 'false'
+            - draft-published-event
+            - comment-added-contains-event:
+                comment-contains-value: 'recheck'
+            - comment-added-contains-event:
+                comment-contains-value: 'reverify'
+          projects:
+            - project-compare-type: 'ANT'
+              project-pattern: '{name}'
+              branches:
+                - branch-compare-type: 'ANT'
+                  branch-pattern: '**/{branch}'
+
+- trigger:
+    name: gerrit-trigger-patch-merged
+    triggers:
+      - gerrit:
+          server-name: 'gerrit-new.automotivelinux.org'
+          trigger-on:
+            - change-merged-event
+            - comment-added-contains-event:
+                comment-contains-value: 'remerge'
+          projects:
+            - project-compare-type: 'ANT'
+              project-pattern: '{name}'
+              branches:
+                - branch-compare-type: 'ANT'
+                  branch-pattern: '**/{branch}'
+
+- trigger:
+    name: gerrit-trigger-silent-patch-submitted
+    triggers:
+      - gerrit:
+          server-name: 'gerrit-new.automotivelinux.org'
+          trigger-on:
+            - patchset-created-event:
+                exclude-drafts: 'false'
+                exclude-trivial-rebase: 'false'
+                exclude-no-code-change: 'false'
+            - draft-published-event
+            - comment-added-contains-event:
+                comment-contains-value: 'recheck'
+            - comment-added-contains-event:
+                comment-contains-value: 'reverify'
+          projects:
+            - project-compare-type: 'ANT'
+              project-pattern: '{name}'
+              branches:
+                - branch-compare-type: 'ANT'
+                  branch-pattern: '**/{branch}'
+          silent-start: 'true'
+
+- trigger:
+    name: gerrit-trigger-silent-full-check
+    triggers:
+      - gerrit:
+          server-name: 'gerrit-new.automotivelinux.org'
+          trigger-on:
+            - comment-added-contains-event:
+                comment-contains-value: 'fullcheck'
+          projects:
+            - project-compare-type: 'ANT'
+              project-pattern: '{name}'
+              branches:
+                - branch-compare-type: 'ANT'
+                  branch-pattern: '**/{branch}'
+          silent-start: 'true'
+
+- trigger:
+    name: gerrit-trigger-silent-patch-merged
+    triggers:
+      - gerrit:
+          server-name: 'gerrit-net.automotivelinux.org'
+          trigger-on:
+            - change-merged-event
+            - comment-added-contains-event:
+                comment-contains-value: 'remerge'
+          projects:
+            - project-compare-type: 'ANT'
+              project-pattern: '{name}'
+              branches:
+                - branch-compare-type: 'ANT'
+                  branch-pattern: '**/{branch}'
+          silent-start: 'true'
+
+- trigger:
+    name: gerrit-trigger-tag
+    triggers:
+      - gerrit:
+          server-name: 'gerrit-new.automotivelinux.org'
+          trigger-on:
+            - ref-updated-event
+          projects:
+            - project-compare-type: 'ANT'
+              project-pattern: '{name}'
+              branches:
+                - branch-compare-type: 'ANT'
+                  branch-pattern: 'refs/tags/**'
+
+# Publishers
+- publisher:
+    name: archive-artifacts
+    publishers:
+      - archive:
+          artifacts: '{artifacts}'
+          allow-empty: true
+          fingerprint: true
+          latest-only: true
+
+- publisher:
+    name: email-notification
+    publishers:
+      - email-ext:
+          recipients: 'nobody@automotivelinux.org'
+          reply-to:
+          content-type: default
+          # yamllint disable rule:line-length
+          subject: '{email-prefix} $PROJECT_NAME - Build # $BUILD_NUMBER - $BUILD_STATUS!'
+          # yamllint enable
+          body: |
+            $PROJECT_NAME - Build # $BUILD_NUMBER - $BUILD_STATUS:
+
+            Check console output at $BUILD_URL to view the results.
+          unstable: true
+          fixed: true
+          send-to:
+            - developers
+            - recipients
+
+# BUILDERS
+- builder:
+    name: ci-management-check-unicode
+    builders:
+      - shell: |
+          $WORKSPACE/scripts/check-unicode.sh jjb/
+
+# WRAPPERS
+- wrapper:
+    name: build-timeout
+    wrappers:
+      - timeout:
+          type: absolute
+          timeout: 360
+          fail: true
+
+- wrapper:
+    # This wrapper is required for all jobs as it configures the wrappers
+    # needed by the automotivelinux.org infra.
+    name: agl-infra-wrappers
+    wrappers:
+      - timeout:
+          type: absolute
+          timeout: '{build-timeout}'
+          timeout-var: 'BUILD_TIMEOUT'
+          fail: true
+      - ssh-agent-credentials:
+          users:
+            - 'agl-jenkins-ssh'
+      - jclouds:
+          single-use: True
diff --git a/packer/README.markdown b/packer/README.markdown
new file mode 100644 (file)
index 0000000..beb0321
--- /dev/null
@@ -0,0 +1,37 @@
+# AutomotiveLinux.org CI Packer
+
+[Packer][1] is a tool for automatically creating VM and container images,
+configuring them and post-processing them into standard output formats.
+
+We build AutomotiveLinux.org's CI images via Packer.
+
+## Building
+
+You'll need to [install Packer][2], of course.
+
+AutomotiveLinux.org's Packer configuration is divided into build-specific variables,
+output-specific templates and a set of shared provisioning scripts. To do a
+specific build, combine the template for the desired output artifact type with
+a variable file. To build a new basebuild instance the following would be done:
+
+```
+packer build -var-file=vars/cloud-env.json -var-file=vars/centos.json templates/basebuild.json
+```
+
+**NOTE:** vars/cloud-env.json is a gitignored file as it contains private
+information. There is a vars/cloud-env.json.example file that may be used as a
+base for creating the one needed.
+
+This would build a bootable image in the AutomotiveLinux.org CI cloud environment.
+
+From a high level, the builds:
+
+* Boot a specified base image in the cloud
+* Run a set of shell scripts, listed in the template's shell provisioner
+  section, to do any configuration required by the builder.
+* Execute a shutdown of the running instance
+* Execute a 'nova image-create' operation against the shutdown instance.
+* Perform a 'nova delete' operation against the shutdown instance.
+
+[1]: https://www.packer.io/
+[2]: https://www.packer.io/intro/getting-started/setup.html
diff --git a/packer/provision/basebuild.sh b/packer/provision/basebuild.sh
new file mode 100644 (file)
index 0000000..01445ff
--- /dev/null
@@ -0,0 +1,4 @@
+#!/bin/bash -x
+# vim: set tw=4 sw=4 sts=4 et :
+
+# Presently nothing to do
diff --git a/packer/provision/basebuild/.dummy b/packer/provision/basebuild/.dummy
new file mode 100644 (file)
index 0000000..e69de29
diff --git a/packer/provision/baseline.sh b/packer/provision/baseline.sh
new file mode 100644 (file)
index 0000000..3678355
--- /dev/null
@@ -0,0 +1,168 @@
+#!/bin/bash
+
+# vim: ts=4 sw=4 sts=4 et tw=72 :
+
+rh_systems() {
+    # Handle the occurance where SELINUX is actually disabled
+    SELINUX=$(grep -E '^SELINUX=(disabled|permissive|enforcing)$' /etc/selinux/config)
+    MODE=$(echo "$SELINUX" | cut -f 2 -d '=')
+    case "$MODE" in
+        permissive)
+            echo "************************************"
+            echo "** SYSTEM ENTERING ENFORCING MODE **"
+            echo "************************************"
+            # make sure that the filesystem is properly labelled.
+            # it could be not fully labeled correctly if it was just switched
+            # from disabled, the autorelabel misses some things
+            # skip relabelling on /dev as it will generally throw errors
+            restorecon -R -e /dev /
+
+            # enable enforcing mode from the very start
+            setenforce enforcing
+
+            # configure system for enforcing mode on next boot
+            sed -i 's/SELINUX=permissive/SELINUX=enforcing/' /etc/selinux/config
+        ;;
+        disabled)
+            sed -i 's/SELINUX=disabled/SELINUX=permissive/' /etc/selinux/config
+            touch /.autorelabel
+
+            echo "*******************************************"
+            echo "** SYSTEM REQUIRES A RESTART FOR SELINUX **"
+            echo "*******************************************"
+        ;;
+        enforcing)
+            echo "*********************************"
+            echo "** SYSTEM IS IN ENFORCING MODE **"
+            echo "*********************************"
+        ;;
+    esac
+
+    echo "---> Updating operating system"
+    yum clean all -q
+    yum install -y -q deltarpm
+    yum update -y -q
+
+    # add in components we need or want on systems
+    echo "---> Installing base packages"
+    yum install -y -q @base https://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm
+    # separate group installs from package installs since a non-existing
+    # group with dnf based systems (F21+) will fail the install if such
+    # a group does not exist
+    yum install -y -q unzip xz puppet git perl-XML-XPath wget make
+
+    # All of our systems require Java (because of Jenkins)
+    # Install all versions of the OpenJDK devel but force 1.7.0 to be the
+    # default
+
+    echo "---> Configuring OpenJDK"
+    yum install -y -q 'java-*-openjdk-devel'
+
+    FACTER_OS=$(/usr/bin/facter operatingsystem)
+    FACTER_OSVER=$(/usr/bin/facter operatingsystemrelease)
+    case "$FACTER_OS" in
+        Fedora)
+            if [ "$FACTER_OSVER" -ge "21" ]
+            then
+                echo "---> not modifying java alternatives as OpenJDK 1.7.0 does not exist"
+            else
+                alternatives --set java /usr/lib/jvm/jre-1.7.0-openjdk.x86_64/bin/java
+                alternatives --set java_sdk_openjdk /usr/lib/jvm/java-1.7.0-openjdk.x86_64
+            fi
+        ;;
+        *)
+            alternatives --set java /usr/lib/jvm/jre-1.7.0-openjdk.x86_64/bin/java
+            alternatives --set java_sdk_openjdk /usr/lib/jvm/java-1.7.0-openjdk.x86_64
+        ;;
+    esac
+}
+
+ubuntu_systems() {
+    # Ignore SELinux since slamming that onto Ubuntu leads to
+    # frustration
+
+    export DEBIAN_FRONTEND=noninteractive
+    cat <<EOF >> /etc/apt/apt.conf
+APT {
+  Get {
+    Assume-Yes "true";
+    allow-change-held-packages "true";
+    allow-downgrades "true";
+    allow-remove-essential "true";
+  };
+};
+
+Dpkg::Options {
+  "--force-confdef";
+  "--force-confold";
+};
+
+EOF
+
+    echo "---> Updating operating system"
+    apt-get update -qq > /dev/null
+    apt-get upgrade -qq > /dev/null
+
+    # add in stuff we know we need
+    echo "---> Installing base packages"
+    apt-get install -qq unzip xz-utils puppet git libxml-xpath-perl make wget > /dev/null
+
+    # install Java 7
+    echo "---> Configuring OpenJDK"
+    apt-get install -qq openjdk-7-jdk > /dev/null
+
+    # make jdk8 available
+    add-apt-repository -y ppa:openjdk-r/ppa > /dev/null
+    apt-get update -qq > /dev/null
+    # We need to force openjdk-8-jdk to install
+    apt-get install -qq openjdk-8-jdk > /dev/null
+
+    # make sure that we still default to openjdk 7
+    update-alternatives --set java /usr/lib/jvm/java-7-openjdk-amd64/jre/bin/java
+    update-alternatives --set javac /usr/lib/jvm/java-7-openjdk-amd64/bin/javac
+}
+
+all_systems() {
+    # Allow jenkins access to update-alternatives command to switch java version
+    cat <<EOF >/etc/sudoers.d/89-jenkins-user-defaults
+Defaults:jenkins !requiretty
+jenkins ALL = NOPASSWD: /usr/bin/update-alternatives
+EOF
+
+    # Do any Distro specific installations here
+    echo "Checking distribution"
+    FACTER_OS=$(/usr/bin/facter operatingsystem)
+    case "$FACTER_OS" in
+        *)
+            echo "---> $FACTER_OS found"
+            echo "No extra steps for $FACTER_OS"
+        ;;
+    esac
+}
+
+echo "---> Attempting to detect OS"
+# upstream cloud images use the distro name as the initial user
+ORIGIN=$(if [ -e /etc/redhat-release ]
+    then
+        echo redhat
+    else
+        echo ubuntu
+    fi)
+#ORIGIN=$(logname)
+
+case "${ORIGIN}" in
+    fedora|centos|redhat)
+        echo "---> RH type system detected"
+        rh_systems
+    ;;
+    ubuntu)
+        echo "---> Ubuntu system detected"
+        ubuntu_systems
+    ;;
+    *)
+        echo "---> Unknown operating system"
+    ;;
+esac
+
+# execute steps for all systems
+all_systems
diff --git a/packer/provision/null_data.sh b/packer/provision/null_data.sh
new file mode 100644 (file)
index 0000000..3fa6a3c
--- /dev/null
@@ -0,0 +1,4 @@
+#!/bin/bash
+# vi: ts=4 sw=4 sts=4 et :
+
+# Nothing to do for Ubuntu specific provisioning
diff --git a/packer/provision/rh-user_data.sh b/packer/provision/rh-user_data.sh
new file mode 100644 (file)
index 0000000..6bddb24
--- /dev/null
@@ -0,0 +1,4 @@
+#!/bin/bash
+# vi: ts=4 sw=4 sts=4 et :
+
+/bin/sed -i 's/ requiretty/ !requiretty/' /etc/sudoers;
diff --git a/packer/provision/system_reseal.sh b/packer/provision/system_reseal.sh
new file mode 100644 (file)
index 0000000..f8bc7dc
--- /dev/null
@@ -0,0 +1,38 @@
+#!/bin/bash
+
+# vim: sw=2 ts=2 sts=2 et :
+
+rm -rf /etc/Pegasus/*.cnf /etc/Pegasus/*.crt /etc/Pegasus/*.csr \
+  /etc/Pegasus/*.pem /etc/Pegasus/*.srl /root/anaconda-ks.cfg \
+  /root/anaconda-post.log /root/initial-setup-ks.cfg /root/install.log \
+  /root/install.log.syslog /var/cache/fontconfig/* /var/cache/gdm/* \
+  /var/cache/man/* /var/lib/AccountService/users/* /var/lib/fprint/* \
+  /var/lib/logrotate.status /var/log/*.log* /var/log/BackupPC/LOG \
+  /var/log/ConsoleKit/* /var/log/anaconda.syslog /var/log/anaconda/* \
+  /var/log/apache2/*_log /var/log/apache2/*_log-* /var/log/apt/* \
+  /var/log/aptitude* /var/log/audit/* /var/log/btmp* /var/log/ceph/*.log \
+  /var/log/chrony/*.log /var/log/cron* /var/log/cups/*_log /var/log/debug* \
+  /var/log/dmesg* /var/log/exim4/* /var/log/faillog* /var/log/gdm/* \
+  /var/log/glusterfs/*glusterd.vol.log /var/log/glusterfs/glusterfs.log \
+  /var/log/httpd/*log /var/log/installer/* /var/log/jetty/jetty-console.log \
+  /var/log/journal/* /var/log/lastlog* /var/log/libvirt/libvirtd.log \
+  /var/log/libvirt/lxc/*.log /var/log/libvirt/qemu/*.log \
+  /var/log/libvirt/uml/*.log /var/log/lightdm/* /var/log/mail/* \
+  /var/log/maillog* /var/log/messages* /var/log/ntp /var/log/ntpstats/* \
+  /var/log/ppp/connect-errors /var/log/rhsm/* /var/log/sa/* /var/log/secure* \
+  /var/log/setroubleshoot/*.log /var/log/spooler* /var/log/squid/*.log \
+  /var/log/syslog* /var/log/tallylog* /var/log/tuned/tuned.log /var/log/wtmp* \
+  /var/named/data/named.run
+
+rm -rf ~/.viminfo /etc/ssh/ssh*key* /root/.ssh/*
+
+# kill any cloud-init related bits
+rm -rf /var/lib/cloud/*
+
+# clean-up any manual packer uploads
+rm -rf /tmp/packer
+
+# Force a system sync and sleep to get around any SSD issues
+echo "Forcing sync and sleep for 10sec"
+sync
+sleep 10
diff --git a/packer/templates/basebuild.json b/packer/templates/basebuild.json
new file mode 100644 (file)
index 0000000..426f290
--- /dev/null
@@ -0,0 +1,52 @@
+{
+  "variables": {
+    "stack_tenant": null,
+    "stack_user": null,
+    "stack_pass": null,
+    "stack_network": null,
+
+    "base_image": null,
+    "cloud_user": null,
+    "distro": null,
+    "cloud_user_data": null
+  },
+  "builders": [
+    {
+      "type": "openstack",
+      "identity_endpoint": "https://auth.vexxhost.net/v2.0/",
+      "tenant_name": "{{user `stack_tenant`}}",
+      "username": "{{user `stack_user`}}",
+      "password": "{{user `stack_pass`}}",
+      "region": "ca-ymq-1",
+      "ssh_username": "{{user `cloud_user`}}",
+      "image_name": "{{user `distro`}} - basebuild - {{isotime \"20060102-1504\"}}",
+      "source_image_name": "{{user `base_image`}}",
+      "flavor": "v1-standard-1",
+      "availability_zone": "ca-ymq-2",
+      "networks": [
+        "{{user `stack_network`}}"
+      ],
+      "user_data_file": "{{user `cloud_user_data`}}"
+    }
+  ],
+  "provisioners": [
+    {
+      "type": "shell",
+      "inline": ["mkdir -p /tmp/packer"]
+    },
+    {
+      "type": "file",
+      "source": "provision/basebuild/",
+      "destination": "/tmp/packer"
+    },
+    {
+      "type": "shell",
+      "scripts": [
+        "provision/baseline.sh",
+        "provision/basebuild.sh",
+        "provision/system_reseal.sh"
+      ],
+      "execute_command": "chmod +x {{ .Path }}; if [ \"$UID\" == \"0\" ]; then {{ .Vars }} '{{ .Path }}'; else {{ .Vars }} sudo -E '{{ .Path }}'; fi"
+    }
+  ]
+}
diff --git a/packer/vars/.gitignore b/packer/vars/.gitignore
new file mode 100644 (file)
index 0000000..af92028
--- /dev/null
@@ -0,0 +1,2 @@
+# exclude private cloud-env settings
+cloud-env.json
diff --git a/packer/vars/cloud-env.json.example b/packer/vars/cloud-env.json.example
new file mode 100644 (file)
index 0000000..3a2ea9d
--- /dev/null
@@ -0,0 +1,6 @@
+{
+  "stack_tenant": "TENANTID",
+  "stack_user": "USERID",
+  "stack_pass": "PASSWD",
+  "stack_network": "NETID",
+}
diff --git a/packer/vars/ubuntu-16.04.json b/packer/vars/ubuntu-16.04.json
new file mode 100644 (file)
index 0000000..c650d07
--- /dev/null
@@ -0,0 +1,7 @@
+{
+  "base_image": "Ubuntu 16.04 LTS (2016-07-22) - LF upload",
+  "cloud_user": "ubuntu",
+
+  "distro": "Ubuntu 16.04",
+  "cloud_user_data": "provision/null_data.sh"
+}
diff --git a/scripts/.gitkeep b/scripts/.gitkeep
new file mode 100644 (file)
index 0000000..e69de29
diff --git a/scripts/check-unicode.sh b/scripts/check-unicode.sh
new file mode 100755 (executable)
index 0000000..db45f6a
--- /dev/null
@@ -0,0 +1,29 @@
+#!/bin/bash
+
+# @License EPL-1.0 <http://spdx.org/licenses/EPL-1.0>
+##############################################################################
+# Copyright (c) 2015 The Linux Foundation and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Eclipse Public License v1.0
+# which accompanies this distribution, and is available at
+# http://www.eclipse.org/legal/epl-v10.html
+#
+# Contributors:
+#   Thanh Ha (The Linux Foundation) - Initial implementation
+##############################################################################
+
+directory="."
+if [ ! -z "$1" ]; then
+    directory="$1"
+fi
+
+echo "Scanning $directory"
+for x in $(find $directory -type f); do
+    if LC_ALL=C grep -q '[^[:print:][:space:]]' "$x"; then
+        echo "file "$x" contains non-ascii characters"
+        exit 1
+    fi
+done
+
+echo "All files are ASCII only"
diff --git a/test b/test
new file mode 100644 (file)
index 0000000..e69de29